"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var grid_layout_1 = require("tns-core-modules/ui/layouts/grid-layout");
var common = require("./calendar.common");
__export(require("./calendar.common"));
var Calendar = (function (_super) {
    __extends(Calendar, _super);
    function Calendar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Calendar.prototype.createRows = function (rows) {
        this.removeRows();
        for (var i = 0; i < rows; i++) {
            this.addRow(new grid_layout_1.ItemSpec(1, "star"));
        }
    };
    Calendar.prototype.onClick = function (e) {
        var motionEvent = e.android;
        var _bounds = new android.graphics.Rect();
        for (var i = 0; i < this.days.length; i++) {
            var day = this.days[i];
            if (day.visibility == "visible") {
                var view = day.nativeView;
                view.getHitRect(_bounds);
                if (_bounds.contains(motionEvent.getX(), motionEvent.getY())) {
                    this.notifyTapped(day);
                    return;
                }
            }
        }
    };
    Calendar.prototype.createDay = function () {
        return new CalendarDay();
    };
    return Calendar;
}(common.Calendar));
exports.Calendar = Calendar;
var CalendarMonthLayout = (function (_super) {
    __extends(CalendarMonthLayout, _super);
    function CalendarMonthLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CalendarMonthLayout.prototype.create = function () {
        return new Calendar();
    };
    return CalendarMonthLayout;
}(common.CalendarMonthLayout));
exports.CalendarMonthLayout = CalendarMonthLayout;
var CalendarDay = (function (_super) {
    __extends(CalendarDay, _super);
    function CalendarDay() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return CalendarDay;
}(common.CalendarDay));
exports.CalendarDay = CalendarDay;
