"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var grid_layout_1 = require("tns-core-modules/ui/layouts/grid-layout");
var label_1 = require("tns-core-modules/ui/label");
var button_1 = require("tns-core-modules/ui/button");
var view_1 = require("ui/core/view");
var gestures_1 = require("ui/gestures");
require("nativescript-nbmaterial-elevation/elevation"); //NEED TO aUGMENT VIEW
require("nativescript-nbmaterial-ripple/ripple"); //NEED TO aUGMENT VIEW
require("nativescript-nbmaterial-layouts/layouts"); //NEED TO AUGMENT PAGE
function safeArray(all) {
    if (!(all instanceof Array)) {
        return [];
    }
    return all;
}
function datesContains(dates, d) {
    return dates.map(Number).indexOf(+d) > -1;
}
function datesRemove(dates, d) {
    var idx = dates.map(Number).indexOf(+d);
    if (idx > -1) {
        dates.splice(idx, 1);
    }
}
function compareDate(d1, d2) {
    if (d1 instanceof Date && d2 instanceof Date) {
        return d1.getTime() == d2.getTime();
    }
    return d1 == d2;
}
function isLeapYear(year) {
    return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
}
;
function getDaysInMonth(year, month) {
    return [31, (isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
}
;
Date.prototype.isLeapYear = function () {
    return isLeapYear(this.getFullYear());
};
Date.prototype.getDaysInMonth = function () {
    return getDaysInMonth(this.getFullYear(), this.getMonth());
};
Date.prototype.addMonths = function (value) {
    var n = this.getDate();
    this.setDate(1);
    this.setMonth(this.getMonth() + value);
    this.setDate(Math.min(n, this.getDaysInMonth()));
    return this;
};
Date.prototype.sameMonth = function (d) {
    return d.getMonth() == this.getMonth() && d.getFullYear() == this.getFullYear();
};
Date.prototype.sameDayOfMonth = function (d) {
    return this.getDate() == d.getDate();
};
//TODO I18
function formatShort(d) {
    var monthNames = ['Janv.', 'Févr.', 'Mars', 'Avril', 'Mai', 'Juin', 'Juil.', 'Août', 'Sept.', 'Oct.', 'Nov.', 'Déc.'];
    var day = d.getDate();
    var monthIndex = d.getMonth();
    var year = d.getFullYear();
    return monthNames[monthIndex] + ' ' + year;
}
var CalendarMonthLayout = (function (_super) {
    __extends(CalendarMonthLayout, _super);
    function CalendarMonthLayout() {
        var _this = _super.call(this) || this;
        //
        _this.current = null;
        _this.other = null;
        _this.callBack = null;
        _this.callSwipe = null;
        _this.current = _this.create();
        _this.other = _this.create();
        //
        _this.current.left = 0;
        _this.current.top = 0;
        _this.other.left = 0;
        _this.other.top = 0;
        //
        _this.addRow(new grid_layout_1.ItemSpec(1, "auto"));
        _this.addRow(new grid_layout_1.ItemSpec(1, "auto"));
        _this.addColumn(new grid_layout_1.ItemSpec(1, "star"));
        _this.addColumn(new grid_layout_1.ItemSpec(5, "star"));
        _this.addColumn(new grid_layout_1.ItemSpec(1, "star"));
        //
        _this.other.row = 1;
        _this.current.row = 1;
        _this.other.colSpan = 3;
        _this.current.colSpan = 3;
        _this.addChild(_this.current);
        _this.addChild(_this.other);
        return _this;
    }
    Object.defineProperty(CalendarMonthLayout.prototype, "multiple", {
        get: function () { return this.current.multiple; },
        set: function (d) {
            d = view_1.booleanConverter(d + "");
            this.current.multiple = d;
            this.other.multiple = d;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarMonthLayout.prototype, "selected", {
        get: function () { return this.current.selected; },
        set: function (s) { this.current.selected = s; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalendarMonthLayout.prototype, "date", {
        get: function () { return this.current.date; },
        set: function (next) { this.current.date = next; },
        enumerable: true,
        configurable: true
    });
    CalendarMonthLayout.prototype.createNativeView = function () {
        return _super.prototype.createNativeView.call(this);
    };
    CalendarMonthLayout.prototype.initNativeView = function () {
        var _this = this;
        _super.prototype.initNativeView.call(this);
        this.other.visibility = "collapse";
        this.callBack = function (e) {
            _this.notify(e);
        };
        this.callSwipe = function (args) {
            switch (args.direction) {
                case gestures_1.SwipeDirection.right:
                    _this.previous();
                    break;
                case gestures_1.SwipeDirection.left:
                    _this.next();
                    break;
            }
        };
        this.current.on(Calendar.dayTappedEvent, this.callBack);
        this.other.on(Calendar.dayTappedEvent, this.callBack);
        this.current.on(gestures_1.GestureTypes.swipe, this.callSwipe);
        this.other.on(gestures_1.GestureTypes.swipe, this.callSwipe);
    };
    CalendarMonthLayout.prototype.disposeNativeView = function () {
        this.current.off(gestures_1.GestureTypes.swipe, this.callSwipe);
        this.other.off(gestures_1.GestureTypes.swipe, this.callSwipe);
        this.current.off(Calendar.dayTappedEvent, this.callBack);
        this.other.off(Calendar.dayTappedEvent, this.callBack);
        this.current = null;
        this.other = null;
        _super.prototype.disposeNativeView.call(this);
    };
    CalendarMonthLayout.prototype.onLoaded = function () {
        _super.prototype.onLoaded.call(this);
    };
    CalendarMonthLayout.prototype.previous = function () {
        this.swap(-1);
    };
    CalendarMonthLayout.prototype.next = function () {
        this.swap(1);
    };
    CalendarMonthLayout.prototype.swap = function (nbMonth) {
        var _this = this;
        var copy = new Date(this.date);
        copy.addMonths(nbMonth);
        this.other.date = copy;
        this.other.update(false); //UPDATE with selected=
        this.other.selected = this.current.selected;
        //
        var promises = [];
        this.other.translateX = nbMonth * this.getMeasuredWidth();
        this.other.visibility = "visible";
        promises.push(this.current.animate({ translate: { x: -nbMonth * this.getMeasuredWidth(), y: 0 } }));
        promises.push(this.other.animate({ translate: { x: 0, y: 0 } }));
        Promise.all(promises).then(function () {
            var temp = _this.current;
            _this.current = _this.other;
            _this.other = temp;
            _this.other.visibility = "collapse";
            //MUST BE CALLED WHEN SWAP FINISHED
            _this.notify({ eventName: CalendarMonthLayout.monthChangedEvent, object: _this });
        });
    };
    return CalendarMonthLayout;
}(grid_layout_1.GridLayout));
CalendarMonthLayout.dayTappedEvent = "dayTapped";
CalendarMonthLayout.monthChangedEvent = "monthChanged";
exports.CalendarMonthLayout = CalendarMonthLayout;
/**
 * CALENDAR TITLE
 */
var CalendarTitle = (function (_super) {
    __extends(CalendarTitle, _super);
    function CalendarTitle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.callBack = null;
        return _this;
    }
    CalendarTitle.prototype.onLoaded = function () {
        var _this = this;
        _super.prototype.onLoaded.call(this);
        this.col = 1;
        this.callBack = function (e) {
            _this.text = formatShort(_this.calendar.date);
        };
        this.text = formatShort(this.calendar.date);
        this.calendar.on(CalendarMonthLayout.monthChangedEvent, this.callBack);
    };
    CalendarTitle.prototype.onUnloaded = function () {
        _super.prototype.onUnloaded.call(this);
        this.calendar.off(CalendarMonthLayout.monthChangedEvent, this.callBack);
    };
    Object.defineProperty(CalendarTitle.prototype, "calendar", {
        get: function () {
            return this.parent;
        },
        enumerable: true,
        configurable: true
    });
    return CalendarTitle;
}(label_1.Label));
exports.CalendarTitle = CalendarTitle;
/**
 * CALENDAR ACTION
 */
var CalendarAction = (function (_super) {
    __extends(CalendarAction, _super);
    function CalendarAction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CalendarAction.prototype.onLoaded = function () {
        var _this = this;
        _super.prototype.onLoaded.call(this);
        this.col = this.action == "previous" ? 0 : 2;
        this.on(gestures_1.GestureTypes.tap, function () {
            _this.action == "previous" ? _this.calendar.previous() : _this.calendar.next();
        });
    };
    Object.defineProperty(CalendarAction.prototype, "calendar", {
        get: function () {
            return this.parent;
        },
        enumerable: true,
        configurable: true
    });
    return CalendarAction;
}(label_1.Label));
exports.CalendarAction = CalendarAction;
/**
 * CALENDAR GRID
 */
var Calendar = (function (_super) {
    __extends(Calendar, _super);
    function Calendar() {
        var _this = _super.call(this) || this;
        _this._needUpdate = true;
        _this._date = new Date();
        _this.clickCallback = null;
        _this.days = [];
        _this.daysName = [];
        _this.cellHeight = null;
        return _this;
    }
    Object.defineProperty(Calendar.prototype, "date", {
        get: function () { return this._date; },
        set: function (next) {
            if (!this._date.sameMonth(next)) {
                this._needUpdate = true;
            }
            this._date = next;
        },
        enumerable: true,
        configurable: true
    });
    Calendar.prototype.createNativeView = function () {
        return _super.prototype.createNativeView.call(this);
    };
    Calendar.prototype.notifyTapped = function (view) {
        this.toggleDay(view);
        var date = this.toDate(view);
        this.updateCssClasses();
        //
        var temp = { tapped: date, selected: this.selected, view: view, eventName: Calendar.dayTappedEvent, object: this };
        this.notify(temp);
    };
    Object.defineProperty(Calendar.prototype, "selected", {
        get: function () {
            return this._selected;
        },
        set: function (d) {
            if (this.multiple) {
                this._selected = safeArray(d);
            }
            else {
                this._selected = d instanceof Date ? d : null;
            }
            this.updateCssClasses();
        },
        enumerable: true,
        configurable: true
    });
    Calendar.prototype.toDate = function (day) {
        var value = parseInt(day.text);
        var date = new Date(this.date.getFullYear(), this.date.getMonth(), value, 0, 0, 0, 0);
        return date;
    };
    Calendar.prototype.toggleDay = function (day) {
        var date = this.toDate(day);
        if (this.multiple) {
            this.selected = safeArray(this.selected);
            if (datesContains(this.selected, this.toDate(day))) {
                datesRemove(this.selected, date);
            }
            else {
                this.selected.push(date);
            }
        }
        else {
            this.selected = compareDate(this.selected, date) ? null : date;
        }
    };
    Calendar.prototype.updateCssClasses = function () {
        var _this = this;
        var toActivate = [];
        if (this.multiple) {
            toActivate = this.selected ? this.selected : toActivate;
        }
        else {
            toActivate = this.selected ? [this.selected] : toActivate;
        }
        //
        var indexes = toActivate.filter(function (d) { return d.sameMonth(_this.date); }).map(function (d) { return d.getDate() - 1; });
        for (var i = 0; i < this.days.length; i++) {
            var day = this.days[i];
            if (indexes.indexOf(i) > -1) {
                day.addCssClass("selected");
            }
            else {
                day.removeCssClass("selected");
            }
        }
    };
    Calendar.prototype.initNativeView = function () {
        var _this = this;
        _super.prototype.initNativeView.call(this);
        this.clickCallback = function (e) {
            _this.onClick(e);
        };
        //DEPRECATED BECAUSE OF BUTTON
        //this.on(GestureTypes.tap, this.clickCallback);
        //
        var names = ["Lu", "Ma", "Me", "Je", "Ve", "Sa", "Di"];
        for (var i = 0; i < 7; i++) {
            var d = this.createDay();
            this.addChild(d);
            d.addCssClass("dayname");
            d.col = i;
            d.row = 0;
            d.text = names[i];
            this.daysName.push(d);
        }
        for (var i = 0; i < 31; i++) {
            var d = this.createDay();
            this.addChild(d);
            this.days.push(d);
        }
        for (var i = 0; i < 7; i++) {
            this.addColumn(new grid_layout_1.ItemSpec(1, "star"));
        }
    };
    Calendar.prototype.disposeNativeView = function () {
        this.days = [];
        this.daysName = [];
        //this.off(GestureTypes.tap, this.clickCallback);
        _super.prototype.disposeNativeView.call(this);
    };
    Calendar.prototype.onLoaded = function () {
        _super.prototype.onLoaded.call(this);
        if (this._needUpdate) {
            this.update(true);
        }
    };
    Calendar.prototype.update = function (withSelected) {
        var firstDay = new Date(this.date.getFullYear(), this.date.getMonth(), 1);
        //PB nb days car day of week dim =0=> dim=6
        var dayOfWeek = (firstDay.getDay() + 6) % 7;
        var nbDays = firstDay.getDaysInMonth();
        var total = dayOfWeek + nbDays;
        var rows = Math.ceil(total / 7); //UPPDER INTEGER
        rows++; //ADD DAY NAMES
        this.createRows(rows);
        //
        var colNum = dayOfWeek; //Monday =1
        var rowNum = 1; //BECAUSE OF DAY NAME
        var now = new Date();
        var nowDay = now.getDate();
        var samePeriod = firstDay.sameMonth(now);
        for (var index_1 = 1; index_1 <= 31; index_1++) {
            var day = this.days[index_1 - 1];
            if (samePeriod && index_1 == nowDay) {
                day.addCssClass("today");
            }
            else {
                day.removeCssClass("today");
            }
            //
            if (index_1 <= nbDays) {
                day.visibility = "visible";
                grid_layout_1.GridLayout.setColumn(day, colNum);
                grid_layout_1.GridLayout.setRow(day, rowNum);
                day.text = index_1 + "";
                if (index_1 <= 9) {
                    day.removeCssClass("big");
                }
                else {
                    day.addCssClass("big");
                }
            }
            else {
                day.visibility = "collapse";
            }
            colNum++;
            //NEXT LINE
            if (7 <= colNum) {
                colNum = 0;
                rowNum++;
            }
        }
        if (withSelected) {
            this.updateCssClasses();
        }
    };
    return Calendar;
}(grid_layout_1.GridLayout));
Calendar.dayTappedEvent = "dayTapped";
exports.Calendar = Calendar;
var CalendarDay = (function (_super) {
    __extends(CalendarDay, _super);
    function CalendarDay() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.callback = null;
        return _this;
    }
    CalendarDay.prototype.onLoaded = function () {
        var _this = this;
        _super.prototype.onLoaded.call(this);
        this.callback = function () {
            _this.parent.notifyTapped(_this);
        };
        this.on(button_1.Button.tapEvent, this.callback);
    };
    CalendarDay.prototype.onUnloaded = function () {
        _super.prototype.onUnloaded.call(this);
        this.off(button_1.Button.tapEvent, this.callback);
    };
    return CalendarDay;
}(button_1.Button));
exports.CalendarDay = CalendarDay;
