"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var common = require("./calendar.common");
var grid_layout_1 = require("tns-core-modules/ui/layouts/grid-layout");
__export(require("./calendar.common"));
var Calendar = (function (_super) {
    __extends(Calendar, _super);
    function Calendar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Calendar.prototype.createRows = function (rows) {
        //NEVER ADD OR REMOVE ROWS ELSE HEIGHT =0
        var MAX_ROWS = 7;
        if (this.getRows().length < MAX_ROWS) {
            for (var i = 0; i < MAX_ROWS; i++) {
                this.addRow(new grid_layout_1.ItemSpec(1, "star"));
            }
        }
    };
    Calendar.prototype.onClick = function (e) {
        var gestureRecognizer = e.ios;
        var view = gestureRecognizer.view;
        var loc = gestureRecognizer.locationInView(view);
        var subview = view.hitTestWithEvent(loc, null);
        for (var i = 0; i < this.days.length; i++) {
            var day = this.days[i];
            if (day.nativeView === subview) {
                this.notifyTapped(day);
                return;
            }
        }
    };
    Calendar.prototype.createDay = function () {
        return new CalendarDay();
    };
    return Calendar;
}(common.Calendar));
exports.Calendar = Calendar;
var CalendarMonthLayout = (function (_super) {
    __extends(CalendarMonthLayout, _super);
    function CalendarMonthLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CalendarMonthLayout.prototype.create = function () {
        return new Calendar();
    };
    return CalendarMonthLayout;
}(common.CalendarMonthLayout));
exports.CalendarMonthLayout = CalendarMonthLayout;
var CalendarDay = (function (_super) {
    __extends(CalendarDay, _super);
    function CalendarDay() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return CalendarDay;
}(common.CalendarDay));
exports.CalendarDay = CalendarDay;
